unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    TreeView1: TTreeView;
    procedure TreeView1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure TreeView1DragDrop(Sender, Source: TObject; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.TreeView1DragDrop(Sender, Source: TObject; X, Y: Integer);
var
    s: string;
begin
    s := '';
    with TListBox(Source) do
        if ItemIndex>=0 then
            s := Items[ItemIndex];
    if s<>'' then with TTreeView(Sender) do begin
        Items.AddChild(DropTarget,s);
        if Assigned(DropTarget) then
            DropTarget.Expand(True);
    end;
end;

procedure TForm1.TreeView1DragOver(Sender, Source: TObject; X, Y: Integer;
    State: TDragState; var Accept: Boolean);
begin
    Accept := (Source=ListBox1);
end;

end.
